/***
 * Julia
 * Copyright (C) 2005-2006 INRIA, France Telecom, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: Lionel.Seinturier@lifl.fr
 *
 * Author: Lionel Seinturier
 */

package membrane;


/**
 * This class illustrates three features which are specific to the {@link
 * org.objectweb.fractal.julia.Juliak} Fractal provider class for developing
 * component-based control membranes:
 * <ul>
 * <li> control membrane introspection </li>
 * <li> gluing of a control membrane to a content instance </li>
 * <li> dynamic management of interceptors </li>
 * <li> joint use of object-oriented and component-based control membranes </li>
 * </ul>
 * 
 * @author Lionel Seinturier <Lionel.Seinturier@lifl.fr>
 */
public class Main {
    
    public static void main(String[] args) throws Exception {

        System.err.println("===================================================");
        System.err.println("==== Control membrane introspection            ====");
        System.err.println("===================================================");
        membrane.introspect.Main.main(args);

        System.err.println();
        System.err.println("===================================================");
        System.err.println("==== Gluing of a control membrane to a content instance");
        System.err.println("===================================================");
        membrane.glue.Main.main(args);

        System.err.println();
        System.err.println("===================================================");
        System.err.println("==== Dynamic management of interceptors        ====");
        System.err.println("===================================================");
        membrane.interceptor.Main.main(args);

        System.err.println();
        System.err.println("===================================================");
        System.err.println("==== Joint use of OO and CB membranes          ====");
        System.err.println("===================================================");
        membrane.mix.Main.main(args);

    }
}
